#!/usr/bin/env python

"""
This test illustrates the need for usage to be propagated forward to the
assignment within the loop.
"""

class C:
    def e(self):    # unused
        return 1

    def f(self):
        return 1

class D:
    def f(self):
        return 2

    def g(self):
        return 3

class E:
    def e(self):
        return 4

    def f(self):
        return 0    # stops the test loop

    def g(self):
        return 5

    def h(self):
        return 6

def test_loop(obj, obj2):
                    # obj: f, g (from loop); f, h (outside loop)
    while obj.f():
                    # obj: g (in loop)
        obj.g()
        obj = obj2  # obj: e, f, h
        obj.e()
                    # (test invoked again)
    return obj.h()

c = C()
d = D()
e = E()
result_6 = test_loop(d, e)

# vim: tabstop=4 expandtab shiftwidth=4
